/*
 * Created on 14 juil. 2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package gus05.entity.gus.collection.map.string.guifactory;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.util.Collections;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;
import java.util.Map;

import gus05.framework.features.Give;
import gus05.framework.features.Retrieve;
import gus05.framework.features.Support;

import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.EmptyBorder;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;


public class MapJPanel extends JPanel implements Give, ActionListener, FocusListener {

    
    private Map map;
    private Retrieve map_ret;
    private Vector keys;
	
    private Map comps;
    
    
    private void updateKeys()
    {
        keys = new Vector(map.keySet());
        Collections.sort(keys);
    }
    
    

    public MapJPanel()
    {
        super();
        comps = new HashMap();
        setBorder(new EmptyBorder(10, 10, 10, 10));
        setLayout(new FormLayout(20, 5)); 
    }

    
    
    
    public void setMap(Map map_)
    {
        if(map!=null)
        if(map instanceof Support)
            ((Support)map).removeActionListener(this);
        
        map = map_;
        if(map==null)return;
	    
        if(map instanceof Support)
            ((Support)map).addActionListener(this);
        
        
        if(map instanceof Retrieve)
            map_ret = (Retrieve)map;
        
        updateKeys();
        updateLabels();
    }
    
    
    public Map getMap()
    {return map;}
    
    public void give(Object obj) throws Exception
    {setMap((Map)obj);}
    
    
    
    
    
    public void actionPerformed(ActionEvent evt)
    {
        if(evt.getSource() instanceof JTextField)
            valueEdited((JTextField)evt.getSource());
        else mapActionPerformed(evt.getActionCommand());
    }
    
    public void focusLost(FocusEvent evt)
	{
		valueEdited((JTextField)evt.getSource());
	}
    
    public void focusGained(FocusEvent evt) {}
	
    

    
    
    private void updateLabels()
    {
        clear();
        
        for(int i=0;i<keys.size();i++)
        {
            String name = (String)keys.get(i);
            JTextField comp = createComp(name);
            comps.put(name,comp);
            addLabel(name,comp);
        }
    }
    
    
    
    
    
    private void valueEdited(JTextField comp)
    {
        String name = comp.getName();
        String value = comp.getText();
        map.put(name,value);
    }
    
    
    
    private void mapActionPerformed(String command)
    {
        if(command.equals("put(Object,Object)"))	put();
        if(command.equals("remove(Object)"))		removed();
        if(command.equals("clear()"))				cleared();
        if(command.equals("putAll(Map)"))			putAll();
    }
    
    
        
        
        
    private void put()
    {
        try
        {
            Object key = map_ret.retrieve("lastKey");
            if(map.size()>keys.size()) addNewKey(key);
            else updateKey(key);
        }
        catch(Exception e){}
    }
    
    
    
    private void putAll()
    {
        keys = new Vector(map.keySet());
        updateLabels();
    }
    
    
    
    private void removed()
    {
        try
        {
            Object key = map_ret.retrieve("lastKey");
            removeKey(key);
        }
        catch(Exception e){}
    }
    
    
    private void cleared()
    {
        keys.clear();
        clear();
    }
    
    
    
    
    private void addNewKey(Object key)
    {
        keys.add(key);
        
        String name = (String)key;
        JTextField comp = createComp(name);
        
        comps.put(name,comp);
        addLabel(name,comp);
    }
    
    
    private void removeKey(Object key)
    {
        int index = keys.indexOf(key);
        keys.remove(key);
        comps.remove(key);
        removeLabelAt(index);
    }
    
    
    private void updateKey(Object key)
    {
        JTextField textField = (JTextField)comps.get(key);
        String value = (String)map.get(key);
        textField.setText(value);
    }
    
    
    
    
    
    
    private JTextField createComp(String name)
    {
        String value = (String)map.get(name);
        JTextField0 textField = new JTextField0(name,value);
        textField.addActionListener(this);
        textField.addFocusListener(this);
        return textField;
    }
    
    

    
    
    private void addLabel(String name, JComponent comp)
    {
        add(new JLabel(name));
        add(comp);
        revalidate();
    }
    
    
    private void insertLabelAt(int index ,String name, JComponent comp)
    {
        add(comp,index*2);
        add(new JLabel(name),index*2);
        revalidate();
    }
    
    
    private void removeLabelAt(int index)
    {
        remove(index*2);
        remove(index*2);
        revalidate();
        repaint();
    }
    
    
    
    
    private void clear()
    {
        Iterator it = comps.keySet().iterator();
        while(it.hasNext())
        {
            Object key = it.next();
            JTextField comp = (JTextField)comps.get(key);
            comp.removeActionListener(this);
        }
        comps.clear();
        removeAll();
        repaint();
    }
    
    
    
    
    private class JTextField0 extends JTextField implements DocumentListener, KeyListener
    {
        private String name;
        public JTextField0(String name, String value)
        {
            super(value);
            this.name = name;
            setName(name);
            getDocument().addDocumentListener(this);
            addKeyListener(this);
        }
        public void insertUpdate(DocumentEvent e) {updateColor();}
        public void removeUpdate(DocumentEvent e) {updateColor();}
        public void changedUpdate(DocumentEvent e) {}
        
        public void keyPressed(KeyEvent e) {}
		public void keyReleased(KeyEvent e) {if(e.getKeyCode()==KeyEvent.VK_ESCAPE) reset();}
		public void keyTyped(KeyEvent e) {}
		
        private void updateColor()
        {
            if(map.get(name).equals(getText()))
                setForeground(Color.BLACK);
            else setForeground(Color.RED);
        }
        
        private void reset()
        {setText("");}
    }




	
}
