/*
 * Created on 10 fvr. 2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package gus05.entity.gus.graphic.textcomp.highlight.scrollbar2;


import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionListener;

import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JScrollBar;
import javax.swing.JTextArea;
import javax.swing.event.CaretEvent;
import javax.swing.event.CaretListener;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.plaf.metal.MetalScrollBarUI;
import javax.swing.text.DefaultHighlighter;
import javax.swing.text.Element;
import javax.swing.text.Highlighter;
import javax.swing.text.PlainDocument;



public class HighScrollBarUI extends MetalScrollBarUI implements DocumentListener, MouseMotionListener, CaretListener, ActionListener {

    
    private JTextArea view;
    private PlainDocument document;
    private Element root;
    
    private JScrollBar bar;
    private Highlighter high;
    

    public HighScrollBarUI(JTextArea view, JScrollBar bar) throws Exception
    {
        this.view = view;
        this.bar = bar;
        high = view.getHighlighter();
        document = (PlainDocument)view.getDocument();
        root = document.getDefaultRootElement();
    }

    
    protected void paintTrack(Graphics g, JComponent c, Rectangle trackBounds)
	{
		super.paintTrack(g,c,trackBounds);
		paintHighlight(g,trackBounds);
	}
    
    
    
    protected void paintThumb(Graphics g, JComponent c, Rectangle thumbBounds)
	{
        super.paintThumb(g,c,thumbBounds);
        paintHighlight(g,getTrackBounds());
        
        g.setColor(view.getForeground());
        g.drawRect(thumbBounds.x,thumbBounds.y,thumbBounds.width,thumbBounds.height);
	}
    
    
    
    
    protected void paintHighlight(Graphics g, Rectangle trackBounds)
    {
        int w = trackBounds.width;
        int h = trackBounds.height;
        
        int x0 = trackBounds.x;
        int y0 = trackBounds.y;
        
        g.setColor(view.getBackground());
        g.fillRect(x0,y0,w,h);
        g.setColor(view.getForeground());
        g.drawRect(x0,y0,w,h);
		
		Highlighter.Highlight[] ht = high.getHighlights();
        for(int i=ht.length-1;i>=0;i--)
        {
            DefaultHighlighter.DefaultHighlightPainter painter = 
                (DefaultHighlighter.DefaultHighlightPainter)ht[i].getPainter();
            
            int start = ht[i].getStartOffset();
            int end = ht[i].getEndOffset();
            
            int startLine = root.getElementIndex(start);
            int endLine = root.getElementIndex(end);
            int lineNumber = root.getElementCount();
            
            int y = (int)(y0 + h*startLine/lineNumber);
            int dy = (int)(h*(endLine - startLine + 1)/lineNumber);
            if(dy==0)dy=1;
            
            Color color = painter.getColor();
            if(color==null)color = view.getSelectionColor();
            
            g.setColor(color);
            g.fillRect(x0,y,w,dy);
        }
    }


    public void insertUpdate(DocumentEvent e) {bar.repaint();}
    public void removeUpdate(DocumentEvent e) {bar.repaint();}
    public void changedUpdate(DocumentEvent e) {bar.repaint();}

    public void actionPerformed(ActionEvent e) {bar.repaint();}
    public void caretUpdate(CaretEvent e) {bar.repaint();}

    public void mouseDragged(MouseEvent e) {bar.repaint();}
    public void mouseMoved(MouseEvent e) {}
    
    
    
    
    
    protected Dimension getMinimumThumbSize()
    {return new Dimension(3,3);}
    
    public JButton getDecrButton()
    {return decrButton;}
    
    public JButton getIncrButton()
    {return incrButton;}
    
}
