
package gus05.entity.gus.graphic.textcomp.highlight.scrollbar2;


import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;

import gus05.framework.core.Entity;
import gus05.framework.features.Transform;

import javax.swing.BoundedRangeModel;
import javax.swing.JScrollBar;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;


/**
* @author gus
*/
public class ScrollBarHighlight2 implements Entity, Transform, MouseListener, MouseMotionListener
{

    public String getName()				{return "gus.graphic.textcomp.highlight.scrollbar2";}
    public String getCreationDate()		{return "2006.12.13";}


    
    public Object transform(Object obj) throws Exception
    {
        JScrollPane scroll = (JScrollPane)obj;
        JTextArea view = (JTextArea)scroll.getViewport().getView();
        JScrollBar bar = scroll.getVerticalScrollBar();
        HighScrollBarUI ui = new HighScrollBarUI(view,bar);
        
        bar.setUI(ui);
        bar.addMouseListener(this);
        bar.addMouseMotionListener(this);
        bar.setBlockIncrement(0);
        
        return ui;
    }
    
    
    public void mouseClicked(MouseEvent e) {}
    public void mouseEntered(MouseEvent e) {}
    public void mouseExited(MouseEvent e) {}
    public void mouseReleased(MouseEvent e) {}
    public void mousePressed(MouseEvent e) {move(e);}
    
    public void mouseDragged(MouseEvent e) {move(e);}
    public void mouseMoved(MouseEvent e) {}
    
    
    
    
    private void move(MouseEvent e)
    {
        JScrollBar bar = (JScrollBar)e.getSource();
        BoundedRangeModel model = bar.getModel();
        HighScrollBarUI ui = (HighScrollBarUI) bar.getUI();
        
        int decr_h = ui.getDecrButton().getHeight();
        int incr_h = ui.getIncrButton().getHeight();
        int h0 = bar.getHeight() - decr_h - incr_h;
        
        double v = (e.getPoint().getY() - incr_h)/(double)h0;
        
        int min = model.getMinimum();
        int max = model.getMaximum();
        
        int newValue = (int)(min + (max-min)*v);
        bar.getModel().setValue(newValue); 
    }
    

    
}
