package gus05.entity.gus.security.app.uservault;


import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.nio.channels.FileChannel;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Map;

import javax.crypto.BadPaddingException;
import javax.swing.JOptionPane;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Provide;



public class UserVault implements Entity, Provide {


    public String getName()				{return "gus.security.app.uservault";}
    public String getCreationDate()		{return "2008.06.28";}



    private Service fileMapPw;
    private Service askPassword;
    
    private File vaultDir;
    private Map map;

    
    
    public UserVault() throws Exception
    {
    	fileMapPw = Outside.service(this,"gus.collection.map.filemap0.pw");
    	askPassword = Outside.service(this,"gus.security.askinfo.password1");
    	vaultDir = (File) Outside.resource(this,"vaultDir");
    }



    public Object provide() throws Exception
    {
    	if(map==null) initMap();
        return map;
    }


    
    private void initMap() throws Exception
    {
    	String password = (String) askPassword.provide();
    	if(password==null) return;
    	
    	File vaultFile = new File(vaultDir,"vault");
    	if(vaultFile.exists()) backupFile(vaultFile);
    	
    	fileMapPw.register("password",password);
    	
    	try
    	{
    		map = (Map) fileMapPw.transform(vaultFile);
    	}
    	catch(BadPaddingException e)
    	{
    		JOptionPane.showMessageDialog(null,"wrong password","failure",JOptionPane.ERROR_MESSAGE);
    	}
    }
    
    
    
    
    
    
    private void backupFile(File f) throws Exception
    {
    	String name = f.getName();
    	File dir = f.getParentFile();
    	File backup = new File(dir,now()+"_"+name);
    	COPY(f,backup);
    }
    
    
    
    private void COPY(File in, File out) throws Exception
    {
        FileInputStream fis = new FileInputStream(in);
        FileOutputStream fos = new FileOutputStream(out);
        
        FileChannel inputChannel = fis.getChannel();
        FileChannel outputChannel = fos.getChannel();
        
        outputChannel.transferFrom(inputChannel,0,in.length());
        
        fis.close();
        fos.close();
    }
    
    private SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMdd_HHmmss");
    private String now() {return sdf.format(new Date());}
}

