package gus05.entity.gus.security.encryption.pbe.string.encrypt;


import java.security.AlgorithmParameters;

import javax.crypto.Cipher;
import javax.crypto.SecretKey;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.PBEKeySpec;
import javax.crypto.spec.PBEParameterSpec;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Transform;



public class PbeEncrypt implements Entity, Transform {


    public String getName()				{return "gus.security.encryption.pbe.string.encrypt";}
    public String getCreationDate()		{return "2008.06.23";}


    public static final String ALGO = "PBEWithMD5AndDES";
    
    private static final byte[] SALT  = new byte[] {0,0,0,0,0,0,0,0};
    private static final int ITERATION = 3;
 
    
    private Service base64Encoder;
    
    private AlgorithmParameters params;
    private SecretKeyFactory keyFactory;
    private Cipher cipher;
    

    
    
    public PbeEncrypt() throws Exception
    {
    	base64Encoder = Outside.service(this,"gus.tostring.bytetobase64");
    	
    	params = AlgorithmParameters.getInstance(ALGO);
    	params.init(new PBEParameterSpec(SALT,ITERATION));
    	keyFactory = SecretKeyFactory.getInstance(ALGO);
    	cipher = Cipher.getInstance(ALGO);
    }



    
    public Object transform(Object obj) throws Exception
    {
    	String password = (String) obj;
		PBEKeySpec keySpec = new PBEKeySpec(password.toCharArray());
		SecretKey key = keyFactory.generateSecret(keySpec);
        return new Encryter(key);
    }


    
    private class Encryter implements Transform
    {
    	private SecretKey key;
    	public Encryter(SecretKey key) {this.key = key;}
    	
		public Object transform(Object obj) throws Exception
		{
			String text = (String) obj;
			cipher.init(Cipher.ENCRYPT_MODE, key, params);
			byte[] cipherbytes = cipher.doFinal(text.getBytes());
			return encode(cipherbytes);
		}
    }
    
    
    private String encode(byte[] data) throws Exception
    {return (String) base64Encoder.transform(data);}
}

